using System;
using System.Collections.Generic;

namespace Jade.DataMining.Classifier
{
    /// <summary>
    /// ȫϢ
    /// </summary>
    public class GlobalInfo
    {
        private static GlobalInfo instance;

        public static GlobalInfo Instance
        {
            get
            {
                if (instance == null)
                {
                    instance = new GlobalInfo(ClassiferSetting.LoadExistModel);
                }
                return instance;
            }
        }

        /// <summary>
        /// transfered id to termId
        /// </summary>
        public Dictionary<int, int> NewIdToId { get; set; }

        /// <summary>
        /// ƺidĶӦ
        /// </summary>
        public Dictionary<string, int> ClassToId { get; set; }

        /// <summary>
        /// idƵĶӦ
        /// </summary>
        public Dictionary<int, string> IdToClass { get; set; }

        /// <summary>
        /// idӳ
        /// </summary>
        public Dictionary<string, int> TermToId { get; set; }

        /// <summary>
        /// idʹӳ
        /// </summary>
        public Dictionary<int, string> IdToTerm { get; set; }

        /// <summary>
        /// idĵƪӳ
        /// </summary>
        public Dictionary<int, int> IdToDocCount { get; set; }

        /// <summary>
        /// ĵĿӳ
        /// </summary>
        public Dictionary<int, int> ClassToDocCount { get; set; }

        /// <summary>
        /// idfĵƵʣӳ
        /// </summary>
        public Dictionary<int, double> IdToIdf { get; set; }

        public GlobalInfo(bool loadFromFile = false)
        {
            if (loadFromFile)
            {
                this.Load();
            }
            else
            {
                TermToId = new Dictionary<string, int>();
                IdToTerm = new Dictionary<int, string>();
                IdToDocCount = new Dictionary<int, int>();
                ClassToDocCount = new Dictionary<int, int>();
                IdToIdf = new Dictionary<int, double>();
                IdToClass = new Dictionary<int, string>();
                ClassToId = new Dictionary<string, int>();
                NewIdToId = new Dictionary<int, int>();
            }
        }

        public void Save()
        {
            try
            {
                var helper = new SerializeHelper();
                helper.ToBinaryFile(TermToId, ClassiferSetting.GlobalSetting.TermToId);
                helper.ToBinaryFile(IdToTerm, ClassiferSetting.GlobalSetting.IdToTerm);
                helper.ToBinaryFile(IdToDocCount, ClassiferSetting.GlobalSetting.IdToDocCount);
                helper.ToBinaryFile(ClassToDocCount, ClassiferSetting.GlobalSetting.ClassToDocCount);
                helper.ToBinaryFile(IdToIdf, ClassiferSetting.GlobalSetting.IdToIdf);
                helper.ToBinaryFile(IdToClass, ClassiferSetting.GlobalSetting.IdToClass);
                helper.ToBinaryFile(ClassToId, ClassiferSetting.GlobalSetting.ClassToId);
                helper.ToBinaryFile(NewIdToId, ClassiferSetting.GlobalSetting.NewidToId);
            }
            catch (Exception ex)
            {
                Log.Exception("Ϣ", ex);
            }
        }

        internal void Load()
        {
            try
            {
                var helper = new SerializeHelper();
                TermToId = helper.FromBinaryFile<Dictionary<string, int>>(ClassiferSetting.GlobalSetting.TermToId);
                IdToTerm = helper.FromBinaryFile<Dictionary<int, string>>(ClassiferSetting.GlobalSetting.IdToTerm);
                IdToDocCount = helper.FromBinaryFile<Dictionary<int, int>>(ClassiferSetting.GlobalSetting.IdToDocCount);
                ClassToDocCount = helper.FromBinaryFile<Dictionary<int, int>>(ClassiferSetting.GlobalSetting.ClassToDocCount);
                IdToIdf = helper.FromBinaryFile<Dictionary<int, double>>(ClassiferSetting.GlobalSetting.IdToIdf);
                IdToClass = helper.FromBinaryFile<Dictionary<int, string>>(ClassiferSetting.GlobalSetting.IdToClass);
                ClassToId = helper.FromBinaryFile<Dictionary<string, int>>(ClassiferSetting.GlobalSetting.ClassToId);
                NewIdToId = helper.FromBinaryFile<Dictionary<int, int>>(ClassiferSetting.GlobalSetting.NewidToId);
            }
            catch
            {
                Console.WriteLine("ȫϢ");
            }
        }
    }
}