using System;
using System.Collections.Generic;
using System.IO;
using System.Text;

namespace Jade.DataMining.Classifier
{
    /// <summary>
    /// ѹϿ
    /// </summary>
    public class SogouRawTextSource : IRawTextSource
    {
        private int currentIndex;
        private List<string> textFiles=new List<string>();
        private Encoding gb2312 = Encoding.GetEncoding("gb2312");
        public SogouRawTextSource(string baseDir)
        {
            if (!Directory.Exists(baseDir))
            {
                throw new Exception("sogouĿ¼");
            }
            textFiles.AddRange(Directory.GetFiles(baseDir, "*.txt", SearchOption.AllDirectories));
            this._isEnd = false;
            this.currentIndex = 0;
        }

        #region Implementation of IRawTextSource

        private bool _isEnd;

        public bool IsEnd
        {
            get { return _isEnd; }
        }

        public RawText GetNextRawText()
        {
            if (currentIndex >= 0 && currentIndex < this.textFiles.Count)
            {
                var currentFile = this.textFiles[currentIndex];
                var text = File.ReadAllText(currentFile, gb2312);
                var category = new DirectoryInfo(currentFile).Name;
                currentIndex++;
                if (currentIndex == this.textFiles.Count)
                {
                    this._isEnd = true;
                }
                return new RawText() { Category = category, Text = text };
            }
            return null;
        }

        private List<RawText> _result;
        public List<RawText> GetAllRawText()
        {
            if (_result == null)
            {
                _result = new List<RawText>();
                System.Threading.Tasks.Parallel.For(0, textFiles.Count, (i) =>
                                                                            {
                                                                                var currentFile = this.textFiles[i];
                                                                                var text = File.ReadAllText(currentFile,
                                                                                                            gb2312);
                                                                                var category =
                                                                                    new DirectoryInfo(currentFile).Name;
                                                                                _result.Add(new RawText()
                                                                                               {
                                                                                                   Category = category,
                                                                                                   Text = text
                                                                                               });
                                                                            });
            }
            return _result;
        }

        #endregion
        }
}