﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jade.DataMining.Classifier;
using System.Diagnostics;
namespace Jade.DataMining
{
    class Program
    {
        static void Main(string[] args)
        {
            //Stopwatch tick = new Stopwatch();
            //tick.Start();
            //var result = 0;
            //tick.Reset();
            //result = 0;
            //tick.Start();
            //System.Threading.Tasks.Parallel.For(1, 20, (i) =>
            //                                                    {
            //                                                        GetData(i);
            //                                                    });
            //tick.Stop();
            //Console.WriteLine(tick.ElapsedTicks);
            //tick.Reset();
            //result = 0;
            //tick.Start();
            //for (var i = 1; i < 20; i++)
            //{
            //    GetData(i);
            //} 
            //tick.Stop();
            //Console.WriteLine(tick.ElapsedTicks);

            var loadModel = ClassiferSetting.LoadExistModel;
            //loadModel = true;
            Text2Matrix text2Matrix = new Text2Matrix(loadModel);
            ChiSquareFilter chiSquareFilter = new ChiSquareFilter(loadModel);
            NaiveBayes bayes = new NaiveBayes(loadModel);

            if (!loadModel)
            {
                Console.WriteLine("开始模型训练...");
                Stopwatch tick = new Stopwatch();
                tick.Start();
                var matrix = text2Matrix.CreateTrainMatrixUserParallel(new SogouRawTextSource(@"E:\语料下载程序\新闻下载\BaiduCrawl\Code\HtmlTest\Jade.Util\Classifier\SogouC.reduced.20061127\SogouC.reduced\Reduced"));
                //var matrix = text2Matrix.CreateTrainMatrix(new TuangouTextSource());
                tick.Stop();
                Console.WriteLine(tick.ElapsedTicks);
                tick.Reset();
                tick.Start();
                matrix = text2Matrix.CreateTrainMatrix(new SogouRawTextSource(@"E:\语料下载程序\新闻下载\BaiduCrawl\Code\HtmlTest\Jade.Util\Classifier\SogouC.reduced.20061127\SogouC.reduced\Reduced"));
                Console.WriteLine(tick.ElapsedTicks);
                Console.WriteLine("卡方检验中...");

                chiSquareFilter.TrainFilter(matrix);

                Console.WriteLine("训练模型中...");

                bayes.Train(matrix);
            }
            var totalCount = 0;
            var accurent = 0;

            var tuangouTest = new TuangouTextSource(@"E:\语料下载程序\新闻下载\BaiduCrawl\Code\HtmlTest\Jade.Util\Classifier\test.txt");

            while (!tuangouTest.IsEnd)
            {
                totalCount++;
                var raw = tuangouTest.GetNextRawText();
                Console.WriteLine("文本：" + raw.Text);
                Console.WriteLine("标记结果：" + raw.Category);
                var category = GetCategory(raw.Text, bayes, chiSquareFilter, text2Matrix);
                Console.WriteLine("结果:" + category);
                if (raw.Category == category)
                {
                    accurent++;
                }
            }

            Console.WriteLine("正确率:" + accurent * 100 / totalCount + "%");

            Console.ReadLine();
        }
        private static int GetData(int i)
        {
            System.Threading.Thread.Sleep(100);
            Console.WriteLine(i.ToString());
            return i;
        }
        private static string GetCategory(string testText, NaiveBayes bayes, ChiSquareFilter chiSquareFilter,
                                         Text2Matrix text2Matrix)
        {
            var textMatrix = text2Matrix.CreatePredictSample(testText);
            chiSquareFilter.SampleFilter(textMatrix);
            var category = bayes.TestSample(textMatrix);
            return category;
        }
    }
}
